/*
hgetptr.c Version 0.1.0  Hash read database block
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* This routine was designed to read */
/* hshhdr->freestk from disk. */
/* However, it is generalized to read */
/* any pointer. */

#include <bthash.h>

off_t hgetptr(hshhdr,ofst)
hashfmt *hshhdr;
off_t ofst;
   {
   off_t loc;
   off_t ptr;
   int rdlen;
   unsigned char *p;
   hshhdr->reason = 0;
   loc = hseek(hshhdr,ofst);
   if (hshhdr->reason) return(UINT_MAX);
   p = (unsigned char *) &ptr;
   rdlen = read(hshhdr->hndl,
      (unsigned char *) p,
      sizeof(off_t));
   if (rdlen == sizeof(off_t))
      {
      return(ptr);
      } /* good read */
   else if (rdlen < 0)
      {
      fprintf(stderr,"hgetptr: error reading database "
	 "ofst %08x rdlen %d)\n",
	 (unsigned int) ofst,
	 rdlen);
      fprintf(stderr,"hndl %d loc %08x errno %d\n",
	 hshhdr->hndl,
	 (unsigned int) loc,
	 errno);
      perror("Read error");
      hshhdr->reason = SYS_ERR + errno;
      return(UINT_MAX);
      } /* read err */
   else
      {
      fprintf(stderr,"hgetptr: error reading database "
	 "ofst %08x rdlen %d)\n",
	 (unsigned int) ofst,
	 rdlen);
      hshhdr->reason = HASH_ERR + 701;
      return(UINT_MAX);
      } /* read err */
   return(UINT_MAX);
   } /* hgetptr */
